/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 */
package com.jcg.prorityqueueexample2;

import java.util.PriorityQueue;
import java.util.Comparator;

/**
 *
 * @author omozegieaziegbe
 */
public class ProrityQueueExample2 {

    public static void main(String[] args) {
        
        // Change the Sorting Order
        PriorityQueue<Book> bookQueue = new PriorityQueue<>((Book b1, Book b2) -> Integer.compare(b2.getYear(), b1.getYear()));

        bookQueue.add(new Book("To Kill a Mockingbird", 1960));
        bookQueue.add(new Book("1984", 1949));
        bookQueue.add(new Book("The Age of Reason", 1794));
        bookQueue.add(new Book("The Great Gatsby", 1925));

        while (!bookQueue.isEmpty()) {
            Book book = bookQueue.poll();
            System.out.println(book);
        }

    }
}
